## spirv-llvm-translator-15 15.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

if(NOT DEFINED BASE_LLVM_VERSION)
  set (BASE_LLVM_VERSION 15.0.0)
endif(NOT DEFINED BASE_LLVM_VERSION)
set(LLVM_SPIRV_VERSION ${BASE_LLVM_VERSION}.0)

include(FetchContent)
include(FindPkgConfig)

option(LLVM_SPIRV_INCLUDE_TESTS
  "Generate build targets for the llvm-spirv lit tests."
  ${LLVM_INCLUDE_TESTS})

if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
  # check if we build inside llvm or not
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(LLVM_SPIRV_BUILD_EXTERNAL YES)
  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)

if(LLVM_SPIRV_BUILD_EXTERNAL)
  # Make sure llvm-spirv gets built when building outside the llvm tree.
  set(LLVM_BUILD_TOOLS ON)
endif(LLVM_SPIRV_BUILD_EXTERNAL)

# Download spirv.hpp from the official SPIRV-Headers repository.
# One can skip this step by manually setting
# LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR path.
if(NOT DEFINED LLVM_TOOL_SPIRV_HEADERS_BUILD AND
   NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
  set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
    "${CMAKE_CURRENT_BINARY_DIR}/SPIRV-Headers")
  message(STATUS "SPIR-V Headers location is not specified. Will try to download
          spirv.hpp from https://github.com/KhronosGroup/SPIRV-Headers into
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
  file(READ spirv-headers-tag.conf SPIRV_HEADERS_TAG)
  # Strip the potential trailing newline from tag
  string(STRIP "${SPIRV_HEADERS_TAG}" SPIRV_HEADERS_TAG)
  FetchContent_Declare(spirv-headers
    GIT_REPOSITORY    https://github.com/KhronosGroup/SPIRV-Headers.git
    GIT_TAG           ${SPIRV_HEADERS_TAG}
    SOURCE_DIR ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}
  )
  FetchContent_MakeAvailable(spirv-headers)
else()
  if(NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
    # This means LLVM_TOOL_SPIRV_HEADERS_BUILD is defined, therefore
    # SPIRV-Headers exist as a subproject.
    set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
      "${CMAKE_SOURCE_DIR}/projects/SPIRV-Headers")
    if(NOT EXISTS ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR})
      message(FATAL_ERROR "No location specified for SPIRV-Headers.
              Try setting the LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
              path or put the project into the llvm/projects folder
              under the name 'SPIRV-Headers'")
    endif()
  endif()
  message(STATUS "Using SPIR-V Headers from
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
endif()

if(LLVM_SPIRV_BUILD_EXTERNAL)
  project(LLVM_SPIRV
    VERSION
      ${LLVM_SPIRV_VERSION}
    LANGUAGES
      CXX
      C
  )

  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  if(LLVM_SPIRV_INCLUDE_TESTS)
    set(LLVM_TEST_COMPONENTS
      llvm-as
      llvm-dis
    )
  endif(LLVM_SPIRV_INCLUDE_TESTS)

  find_package(LLVM ${BASE_LLVM_VERSION} REQUIRED
    COMPONENTS
      Analysis
      BitReader
      BitWriter
      CodeGen
      Core
      Passes
      Support
      TransformUtils
      ${LLVM_TEST_COMPONENTS}
  )
  set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${LLVM_CMAKE_DIR}
  )
  include(AddLLVM)
  include(HandleLLVMOptions)

  message(STATUS "Found LLVM: ${LLVM_VERSION}")

  option(CCACHE_ALLOWED "allow use of ccache" TRUE)
  find_program(CCACHE_EXE_FOUND ccache)
  if(CCACHE_EXE_FOUND AND CCACHE_ALLOWED)
    message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

set(LLVM_SPIRV_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)

pkg_search_module(SPIRV_TOOLS SPIRV-Tools)
if(NOT SPIRV_TOOLS_FOUND)
  message(STATUS "SPIRV-Tools not found; project will be built without "
          "--spirv-tools-dis support.")
endif(NOT SPIRV_TOOLS_FOUND)

add_subdirectory(lib/SPIRV)
add_subdirectory(tools/llvm-spirv)
if(LLVM_SPIRV_INCLUDE_TESTS)
  add_subdirectory(test)
endif(LLVM_SPIRV_INCLUDE_TESTS)

install(
  FILES
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVOpts.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVExtensions.inc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
)

configure_file(LLVMSPIRVLib.pc.in ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
)

=== lib/SPIRV/CMakeLists.txt ===
add_llvm_library(LLVMSPIRVLib
  LLVMSPIRVOpts.cpp
  LLVMToSPIRVDbgTran.cpp
  Mangler/FunctionDescriptor.cpp
  Mangler/Mangler.cpp
  Mangler/ManglingUtils.cpp
  Mangler/ParameterType.cpp
  OCLToSPIRV.cpp
  OCLTypeToSPIRV.cpp
  OCLUtil.cpp
  VectorComputeUtil.cpp
  SPIRVLowerBitCastToNonStandardType.cpp
  SPIRVLowerBool.cpp
  SPIRVLowerConstExpr.cpp
  SPIRVLowerMemmove.cpp
  SPIRVLowerOCLBlocks.cpp
  SPIRVLowerSaddIntrinsics.cpp
  SPIRVReader.cpp
  SPIRVRegularizeLLVM.cpp
  SPIRVToLLVMDbgTran.cpp
  SPIRVToOCL.cpp
  SPIRVToOCL12.cpp
  SPIRVToOCL20.cpp
  SPIRVTypeScavenger.cpp
  SPIRVUtil.cpp
  SPIRVWriter.cpp
  SPIRVWriterPass.cpp
  PreprocessMetadata.cpp
  libSPIRV/SPIRVBasicBlock.cpp
  libSPIRV/SPIRVDebug.cpp
  libSPIRV/SPIRVDecorate.cpp
  libSPIRV/SPIRVEntry.cpp
  libSPIRV/SPIRVFunction.cpp
  libSPIRV/SPIRVInstruction.cpp
  libSPIRV/SPIRVModule.cpp
  libSPIRV/SPIRVStream.cpp
  libSPIRV/SPIRVType.cpp
  libSPIRV/SPIRVValue.cpp
  LINK_COMPONENTS
    Analysis
    BitWriter
    CodeGen
    Core
    Demangle
    IRReader
    Linker
    Passes
    Support
    TransformUtils
  DEPENDS
    intrinsics_gen
)

target_include_directories(LLVMSPIRVLib
  PRIVATE
    ${LLVM_INCLUDE_DIRS}
    ${LLVM_SPIRV_INCLUDE_DIRS}
    # TODO: Consider using SPIRV-Headers' as a header-only INTERFACE
    # instead. Right now this runs into exporting issues with
    # the LLVM in-tree builds.
    ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/libSPIRV
    ${CMAKE_CURRENT_SOURCE_DIR}/Mangler
)

=== debian/changelog ===
spirv-llvm-translator-15 (15.0.0-7build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:49:59 +1100

spirv-llvm-translator-15 (15.0.0-7) unstable; urgency=medium

  * Skip upstream testsuite on big-endian architectures (> 60% of the tests
    are failing anyway but ignored) due to excessive disk space usage
    (> 40 GB).  (Closes: #1065395)
  * Update from llvm_release_150 branch (v15.0.0-85-gda050541).
  * Disable two commits causing test failures.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Mar 2024 20:01:08 +0100

spirv-llvm-translator-15 (15.0.0-6) unstable; urgency=medium

  * Add build-needed autopkgtest for spirv-headers compat check.
  * Update from llvm_release_150 branch (v15.0.0-79-gc1f08b41).
  * Bump spirv-headers dependency to 1.6.1+1.3.275.0.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 08 Feb 2024 22:48:18 +0100

spirv-llvm-translator-15 (15.0.0-5) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 13:48:15 +0200

spirv-llvm-translator-15 (15.0.0-4) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Update .symbols control file for gcc-13 builds.

  [ Gianfranco Costamagna ]
  * Mark some more symbols as optional as they don't appear on Ubuntu (LTO?).
    (Closes: #1042819)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 03 Aug 2023 11:46:40 +0200

spirv-llvm-translator-15 (15.0.0-3) unstable; urgency=medium

  * Fix compatibility with newer spirv-as.  (Closes: #1040056)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 11 Jul 2023 15:05:17 +0200

spirv-llvm-translator-15 (15.0.0-2) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-14 14.0.0-5.
  * Restrict watch file to 15.* releases.
  * Bump Standards-Version to 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 04 Apr 2023 11:24:20 +0200

spirv-llvm-translator-15 (15.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-15.
  * Rename binary packages: *14* => *15*.
  * Build with llvm 15.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 03 Oct 2022 02:09:37 +0200

spirv-llvm-translator-14 (14.0.0-12) unstable; urgency=medium

  * Update from llvm_release_140 branch (v14.0.0-179-gd54b2cea).
  * Disable the upstream-testsuite autopkgtest on s390x.  (Closes: #1065395)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 06 Mar 2024 12:21:28 +0100

spirv-llvm-translator-14 (14.0.0-11) unstable; urgency=medium

  * Update from llvm_release_140 branch (v14.0.0-177-g0141f3dd).
  * Skip tests on big-endian architectures (> 60% are failing) due to
    excessive disk space usage (>40 GB). The failures are ignored on !amd64
    anyway.  (Closes: #1065395)
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Mar 2024 05:13:45 +0100

spirv-llvm-translator-14 (14.0.0-10) unstable; urgency=medium

  * Add build-needed autopkgtest for spirv-headers compat check.
  * Update from llvm_release_140 branch (v14.0.0-172-gc3dc6b81).
  * Bump spirv-headers dependency to 1.6.1+1.3.275.0.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 08 Feb 2024 03:47:14 +0100

spirv-llvm-translator-14 (14.0.0-9) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 13:39:11 +0200

spirv-llvm-translator-14 (14.0.0-8) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Mark some more symbols as optional as they don't appear on Ubuntu (LTO?).
    (Closes: #1042819)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 01 Aug 2023 14:45:06 +0200

spirv-llvm-translator-14 (14.0.0-7) unstable; urgency=medium

  * Update .symbols control file for gcc-13 builds.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 31 Jul 2023 11:05:53 +0200

spirv-llvm-translator-14 (14.0.0-6) unstable; urgency=medium

  * Fix compatibility with newer spirv-as.  (Closes: #1040055)
  * Bump Standards-Version to 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 11 Jul 2023 14:03:54 +0200

spirv-llvm-translator-14 (14.0.0-5) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Oct 2022 09:11:37 +0200

spirv-llvm-translator-14 (14.0.0-4) unstable; urgency=medium

  * Build with -fvisibility=hidden -fvisibility-inlines-hidden.
  * Drop hidden symbols from .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Oct 2022 17:41:42 +0200

spirv-llvm-translator-14 (14.0.0-3) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 02 Oct 2022 13:48:53 +0200

spirv-llvm-translator-14 (14.0.0-2) unstable; urgency=medium

  * Restrict watch file to 14.* releases.
  * Build with spirv-tools.
  * Add autopkgtest, ignore failures on !amd64.
  * Enable build-time tests, ignore failures on !amd64.
  * Use pkg-kde-tools to manage the .symbols.
  * Add .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 30 Sep 2022 18:00:36 +0200

spirv-llvm-translator-14 (14.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-14.
  * Rename binary packages: *13* => *14*.
  * Build with llvm 14.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 16 May 2022 09:29:32 +0200

spirv-llvm-translator (13.0.0-6) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 30 Sep 2022 16:36:05 +0200

spirv-llvm-translator (13.0.0-5) unstable; urgency=medium

  * Use pkg-kde-tools to manage the .symbols.
  * Add .symbols control file.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Sep 2022 22:34:44 +0200

spirv-llvm-translator (13.0.0-4) unstable; urgency=medium

  * Rename /usr/bin/llvm-spirv to /usr/bin/llvm-spirv-13.
  * Restrict watch file to 13.* releases.
  * Enable all hardening flags.
  * Bump Standards-Version to 4.6.1.



=== debian/control ===
Source: spirv-llvm-translator-15
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 gcc (>= 4:13),
 pkgconf,
 spirv-headers (>= 1.6.1+1.3.275.0),
 spirv-tools,
# keep the clang/llvm version in sync, don't forget debian/tests/control
 libclang-15-dev,
 llvm-15-dev,
 clang-15 <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm15/main

Package: libllvmspirvlib15
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV -- shared library
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the shared library.

Package: libllvmspirvlib-15-dev
Architecture: any
Multi-Arch: same
Depends:
 libllvmspirvlib15 (= ${binary:Version}),
 ${misc:Depends}
Conflicts:
 libllvmspirvlib-x.y-dev,
Breaks:
 libllvmspirvlib-dev (<< 13.0.0-3~),
Replaces:
 libllvmspirvlib-dev (<< 13.0.0-3~),
 libllvmspirvlib-x.y-dev,
Provides:
 libllvmspirvlib-x.y-dev,
Description: bi-directional translator for LLVM/SPIRV -- development files
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes static libs and headers for development.

Package: llvm-spirv-15
Architecture: any
Depends:
 libllvmspirvlib15 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the llvm-spirv-15 binary.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?(15\.[\d.]*)\.tar\.gz

## spirv-llvm-translator-15 15.0.1

=== debian/changelog ===
spirv-llvm-translator-15 (15.0.1-1~ubuntu0.24.04.1) noble; urgency=medium

  * Backport to noble. (LP: #2111480)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 28 Jul 2025 13:56:54 +0300

spirv-llvm-translator-15 (15.0.1-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1073426)
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 18 Jun 2024 14:51:41 +0200

spirv-llvm-translator-14 (14.0.1-2) unstable; urgency=medium

  * Update .symbols control file.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 17 Jun 2024 15:41:43 +0200

spirv-llvm-translator-14 (14.0.1-1) experimental; urgency=medium

  * New upstream release.
  * Update .symbols control file.
  * Bump Standards-Version to 4.7.0, no changes needed.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 14 Jun 2024 11:31:37 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: spirv-llvm-translator-15
 Section: libdevel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
+Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
 Uploaders:
  Timo Aaltonen <tjaalton@debian.org>,
  Andreas Beckmann <anbe@debian.org>,
@@ -18,7 +17,7 @@
  llvm-15-dev,
  clang-15 <!nocheck>,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm15/main

=== debian/tests/control ===
Tests: upstream-testsuite
Architecture: amd64
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 clang-15,
 llvm-15-dev,
Restrictions:
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite
Features: test-name=upstream-testsuite-flaky
Architecture: !amd64 !s390x
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 clang-15,
 llvm-15-dev,
Restrictions:
 allow-stderr,
 flaky,

Test-Command: true
Features: test-name=spirv-headers-compatibility
Depends:
 spirv-headers,
Restrictions:
 build-needed,
 allow-stderr,
 superficial,

## spirv-llvm-translator-15 15.0.3

=== debian/changelog ===
spirv-llvm-translator-15 (15.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.3-2.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Aug 2024 09:54:22 +0200

spirv-llvm-translator-14 (14.0.3-2) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 22 Aug 2024 18:07:54 +0200

spirv-llvm-translator-14 (14.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file for gcc-14 builds.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 22 Aug 2024 12:08:12 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-pkgkde-symbolshelper,
  cmake,
- gcc (>= 4:13),
+ gcc (>= 4:14),
  pkgconf,
  spirv-headers (>= 1.6.1+1.3.275.0),
  spirv-tools,
